﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.Editors;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            ObservableCollection<MyData> data = new ObservableCollection<MyData>();
            data.Add(new MyData() { Count = 5.0, CountString = "five" });
            data.Add(new MyData() { Count = 1.0, CountString = "one" });
            data.Add(new MyData() { Count = 9.0, CountString = "nine" });

            this.DataContext = data;
        }
    }

    public class MyData
    {
        public double Count { get; set; }
        public string CountString { get; set; }
    }

    public class DoubleToStringConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            DataRecordPresenter drp = Utilities.GetAncestorFromType(parameter as DependencyObject, typeof(DataRecordPresenter), true) as DataRecordPresenter;
            if ((drp.Record as DataRecord).DataItemIndex >= 0)
            {
                return ((drp.Record as DataRecord).DataItem as MyData).CountString;
            }

            return Binding.DoNothing;            
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

}
